uses keys,ObjGfx0,ObjGfx8;
var screen:TScreen8;
    pic:Tgfx8;
    quad1,quad2,quad3,quad4:Pgfx8;
begin
 screen.init;  {Init the screen object}
 pic.init;     {Init the pic object}

 if not pic.getmem(640,400) then {make sure the mem was allocated}
  begin
   writeln('error allocating memory');
   halt
  end;

 new(quad1,init);  {dynamically allocate quadrant}
 new(quad2,init);  {dynamically allocate quadrant}
 new(quad3,init);  {dynamically allocate quadrant}
 new(quad4,init);  {dynamically allocate quadrant}

 quad1^.aliasgfx8(pic,0,0,319,199);     {alias upper left quadrant}
 quad2^.aliasgfx8(pic,320,0,639,199);   {alias upper right quadrant}
 quad3^.aliasgfx8(pic,0,200,319,399);   {alias lower left quadrant}
 quad4^.aliasgfx8(pic,320,200,640,399); {alias lower right quadrant}

 if not quad1^.loadgfx('ship1.msh') then  {loads into upper left}
  begin
   writeln('Error loading ship1.msh');
   halt
  end;
 if not quad2^.loadgfx('ship2.msh') then  {loads into upper right}
  begin
   writeln('Error loading ship2.msh');
   halt
  end;
 if not quad3^.loadgfx('ship3.msh') then  {loads into lower left}
  begin
   writeln('Error loading ship3.msh');
   halt
  end;
 if not quad4^.loadgfx('ship4.msh') then  {loads into lower right}
  begin
   writeln('Error loading ship4.msh');
   halt
  end;

 if not screen.setmode(_640x480x8bpp) then {try setting the vid mode}
  begin
   writeln('Error setting video mode');
   halt
  end;

 {Note: each of the aliased sections contains the palette for each mooishi.
  Doing: screen.pal:=quad1^.pal would work just as well as this next line:}

 screen.loadpal('ship.pal');  {load the pal out of this file}
 screen.makepal;              {set the palette}
 screen.flip(pic);            {copy image to the screen}

 pic.pal:=screen.pal;         {IMPORTANT: set the pic palette to the actual one}
 pic.savegfx('ship.msh',MSH); {Save whole image as a MSH}
{ pic.savegfx('ship.pcx',PCX);}

 readkey;                     {wait for a key}

 {Dispose of the aliasing gfx8 objects}
 dispose(quad4,done);
 dispose(quad3,done);
 dispose(quad2,done);
 dispose(quad1,done);

 screen.done; {kill the screen; restore vid mode}
 pic.done;    {kill the pic; free the mem}
end.
